Attribute VB_Name = "PhVintSetup"
Option Explicit

   ' Create a TYPE for the data required for each I/O point
   Public Type ChInfo
      ' Values entered by user
      devName As String    ' Device Name
      devClass As String   ' DigOut, DigInp, Encoder, Stepper
      hubSn As Long        ' Nbr on back of Hub
      isHub As Long        ' 1 if using Hub Port as I/O point
      port As Long         ' Hub Port number
      ch As Long           ' Module channel number (0 if Hub)
      
      ' The following value is created by program
      hndl As Long         ' Handle is created with 'Create device'
   End Type
      
   ' Make an array large enough for all I/O points
   Public Dev(31) As ChInfo ' 0-31 using max of 32 devices
   Public Const timeOutMs& = 1000
   Public NbrOfDev&

   
   ' Typical C++ data type for VINT (from Phidgets C++ example)
   '
   '   Public Type NetInfo
   '      isRemote As Long
   '      serverDiscovery As Long
   '      hostName As String
   '      netPort As Long
   '      password As String
   '   End Type
   '
   '   Public Type ChInfo
   '      deviceSerialNumber As Long
   '      hubPort As Long
   '      channel As Long
   '      isHub As Long  ' Is this a Hub Port device
   '      isVINT As Long ' Is this a VINT device
   '      netInf As NetInfo
   '   End Type

' ===========================================================================
Public Static Sub SetupAllDevices()
   ' User setup data
   ' Enter SN#, isHub, port, and ch for each I/O point
   
   Dim stat&
   Dim indx&
   ' Each I/O point is given an index number.  This is passed to the
   ' Phiget22 DLL (as userData) when the callbacks (events) are set up.
   ' When an event occurs, the handle and index (userData) are sent
   ' back to the callback routine (eg. OnError) and used as as the
   ' ChInfo() index to reference which I/O point the event belongs to.
   
   ' =================================================
   ' All hub hubPorts used for I/O are channel 0
   indx& = 0
   Dev(indx&).devName = "HubOut 00"    ' Enter name of device
   Dev(indx&).devClass = "DigOut"      ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
   Dev(indx&).isHub = 1                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 3                 ' Hub port (0-5)
   Dev(indx&).ch = 0                   ' Channel (Hub is always 0)
   Call InitPhDigOut(indx&, stat&)     ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup VINT Hub hubPort 3 for Digital Output Mode (LED)
   indx& = 1
   Dev(indx&).devName = "DigOut 00"    ' Enter name of device
   Dev(indx&).devClass = "DigOut"      ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 0                 ' Hub port for REL1100 (0-5)
   Dev(indx&).ch = 0                   ' Channel on REL1100 (0-3)
   Call InitPhDigOut(indx&, stat&)     ' Create Dev(indx&).hndl
   ' Note: indx& can be any long value.
   '       It is returned with events for this I/O point
   '       I'm using it as an index for Dev() array
   '       Dev().indx& is returned as with events as userData.
   '       This is used to index the Dev() array for data
   
   ' =================================================
   indx& = 2
   Dev(indx&).devName = "DigOut 01"    ' Enter name of device
   Dev(indx&).devClass = "DigOut"      ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Serial number for MY hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 0                 ' Hub port (0-5)
   Dev(indx&).ch = 1                   ' Channel (Hub is always 0)
   Call InitPhDigOut(indx&, stat&)     ' Create Dev(indx&).hndl
   
   ' =================================================
   indx& = 3
   Dev(indx&).devName = "DigOut 02"    ' Enter name of device
   Dev(indx&).devClass = "DigOut"      ' Enter class of device
   Dev(indx&).hubSn = 527576           ' SN# for hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 0                 ' Hub port number (0-5)
   Dev(indx&).ch = 2                   ' Module channel or 0 for Hub
   Call InitPhDigOut(indx&, stat&)     ' Create Dev(indx&).hndl
   
   ' =================================================
   indx& = 4
   Dev(indx&).devName = "DigOut 03"    ' Enter name of device
   Dev(indx&).devClass = "DigOut"      ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 0                 ' Hub port for REL1100 (0-5)
   Dev(indx&).ch = 3                   ' Channel (Hub is always 0)
   Call InitPhDigOut(indx&, stat&)     ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup VINT Hub hubPort 1 for STC1001 Stepper 0
   indx& = 5
   Dev(indx&).devName = "Stepper 0"    ' Enter name of device
   Dev(indx&).devClass = "Stepper"     ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 1                 ' Hub port (0-5)
   Dev(indx&).ch = 0                   ' Channel (Hub is always 0)
   Call InitPhStepper(indx&, stat&)    ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup VINT Hub hubPort 2 for STC1001 Stepper 1
   indx& = 6
   Dev(indx&).devName = "Stepper 1"    ' Enter name of device
   Dev(indx&).devClass = "Stepper"     ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 2                 ' Hub port (0-5)
   Dev(indx&).ch = 0                   ' Channel (Hub is always 0)
   Call InitPhStepper(indx&, stat&)    ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup VINT Hub hubPort 4 for LCD Display Module
   indx& = 7
   Dev(indx&).devName = "Lcd Display 0" ' Enter name of device
   Dev(indx&).devClass = "Lcd"         ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 4                 ' Hub port (0-5)
   Dev(indx&).ch = 0                   ' Channel (Hub is always 0)
   Call InitPhLcd(indx&, stat&)       ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup VINT Hub hubPort 5 for ENC1000 Encoder
   indx& = 8
   Dev(indx&).devName = "Encoder"     ' Enter name of device
   Dev(indx&).devClass = "Encoder"     ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 5                 ' Hub port (0-5)
   Dev(indx&).ch = 0                   ' Channel (Hub is always 0)
   Call InitPhEncoder(indx&, stat&)    ' Create Dev(indx&).hndl
   
   NbrOfDev& = indx& + 1               ' include indx&(0)

End Sub

' ===========================================================================
Public Static Sub CloseAllDevices()
   
   Dim indx&
   Dim stat&
   
   ' Close and Delete all channels
   ' Ok to close devices that do not exist
   For indx& = 0 To NbrOfDev& - 1
      ' Use common "close" for all channels
      stat& = PhClose(Dev(indx&).hndl)
      
      ' Devices (channels) are created using their "class".  They
      ' must also be deleted by class.  The devClass is set during
      ' entry of setup pramaters.
      Select Case Dev(indx&).devClass
         Case "DigOut"
            stat& = PhDigOutDelete&(Dev(indx&).hndl)
         Case "DigInp"
            stat& = PhDigInpDelete&(Dev(indx&).hndl)
         Case "Encoder"
            stat& = PhEncDelete&(Dev(indx&).hndl)
         Case "Stepper"
            stat& = PhStepDelete&(Dev(indx&).hndl)
         Case "Lcd"
            stat& = PhLcdDelete&(Dev(indx&).hndl)
      End Select ' Dev(inds&).devClass
   Next indx&

   Sleep (500) ' Allow time to close before Ending (avoid crash)

End Sub
